require_dependency "fbuser/api/v1/application_controller"

module Fbuser
  class Api::V1::AuthenticationController < Api::V1::ApplicationController
    skip_before_filter :authenticate_user, only: [:login]

    def login
      short_token = params[:token]
      fb_api = ::Fbuser::Facebook.new
      long_token = fb_api.get_long_token(short_token)
      fb_user_id = get_id(fb_api,long_token,short_token)
      if fb_user_id.nil?
        #Couldn't retrieve the facebook user_id from token
        render :json => {error: "Could not retrieve the facebook user_id from your token"}
        return
      end
      @user = ::Fbuser::V1::User.find_by(fb_user_id: fb_user_id)
      if @user.nil?
        #Create new user
        params = {username: "user#{fb_user_id}", fb_user_id: fb_user_id}
        @user = ::Fbuser::V1::User.create(params)
        @api_token = @user.tokens[0]
      else
        #Log in a user
        @api_token = @user.tokens.create
      end
      ::Arcadex::Create.set_token(@api_token,20000,request,nil)
      userHash = {id: @user.id, username: @user.username, fb_user_id: @user.fb_user_id}
      objHash = {user: userHash, api_token: @api_token.auth_token, fb_token: @token}
      render :json => objHash
    end

    def logout
      current_token.destroy
      render :json => {}
    end

    private

      def get_id(fb_api,long_token,short_token)
        response = fb_api.get_user_id(long_token)
        if response.code == 200
          @token = long_token
          return JSON.parse(response.body)["id"]
        end
        #Lets try it with the short token now
        response = fb_api.get_user_id(short_token)
        if response.code == 200
          @token = short_token
          return JSON.parse(response.body)["id"]
        end
        return nil
      end

  end
end
