require_dependency "fbuser/api/v1/application_controller"
require 'authorization'

module Fbuser
  class Api::V1::UsersController < Api::V1::ApplicationController
    before_action :set_user, only: [:show, :update, :destroy]
    before_action :index_authorize, only: [:index]
    before_action :show_authorize, only: [:show]
    before_action :create_authorize, only: [:create]
    before_action :update_authorize, only: [:update]
    before_action :destroy_authorize, only: [:destroy]

		# GET /api/1/users
    def index
      @users = ::Fbuser::V1::User.all
      render json: @users
    end

    # GET /api/1/users/1
    def show
    	render json: @user
    end

=begin
    # POST /api/1/users
    def create
      @user = ::Fbuser::V1::User.new(user_params)
      if @user.save
        render json: @user
      else
        render :json => {errors: @user.errors.full_messages}, status: :unprocessable_entity
      end
    end
=end

    # PATCH/PUT /api/1/users/1
    def update
    	if @user.update(user_params)
        render json: @user
      else
        render :json => {errors: @user.errors.full_messages}, status: :unprocessable_entity
      end
    end

    # DELETE /api/1/users/1
    def destroy
      @user.destroy
      render json: {}
    end

    private

      # Use callbacks to share common setup or constraints between actions.

      def set_user
        @user = ::Fbuser::V1::User.find_by_id(params[:id])
        if @user.nil?
          render :json => {errors: "User was not found"}, status: :not_found
        end
      end

      # Only allow a trusted parameter "white list" through.

      def user_params
        params.require(:user).permit(:username,:fb_user_id)
      end

      # Authorizations below here

      def index_authorize
        if !::Authorization::Fbuser::V1::User.index?(current_user)
          render :json => {errors: "User is not authorized for this action"}, status: :forbidden
        end
      end

      def show_authorize
        if !::Authorization::Fbuser::V1::User.show?(@user,current_user)
          render :json => {errors: "User is not authorized for this action"}, status: :forbidden
        end
      end

      def create_authorize
        if !::Authorization::Fbuser::V1::User.create?(user_params,current_user)
          render :json => {errors: "User is not authorized for this action"}, status: :forbidden
        end
      end

      def update_authorize
        if !::Authorization::Fbuser::V1::User.update?(@user,user_params,current_user)
          render :json => {errors: "User is not authorized for this action"}, status: :forbidden
        end
      end

      def destroy_authorize
        if !::Authorization::Fbuser::V1::User.destroy?(@user,current_user)
          render :json => {errors: "User is not authorized for this action"}, status: :forbidden
        end
      end
  end
end
