require 'type_cartographer'

module Fbuser
  class V1::User < ActiveRecord::Base
  	self.table_name = 'fbuser_users'
  	
  	before_validation :sanitize_attributes
  	after_create :setup_user

  	has_many :tokens, :as => :imageable, :class_name => "::Arcadex::Token", dependent: :destroy

  	validates :fb_user_id, presence: true

		def setup_user
			create_token
		  return true
		end

    def create_token
      self.tokens.create!
      return true
    end

    def sanitize_attributes
      if self.username.nil? || self.username.blank?
        self.username = "username"
      end
      return true
    end

  end
end
