ActiveAdmin.register Fbuser::User do

  menu :label => "FBUsers"
  config.per_page = 30

=begin
  batch_action :flag do |selection|
    Fbuser::User.find(selection).each { |p| p.flag! }
    redirect_to collection_path, :notice => "FBUsers flagged!"
  end
=end

  form do |f|
    f.semantic_errors # shows errors on :base
    #f.inputs          # builds an input field for every attribute
    f.inputs do
      f.input :id
      f.input :username
      f.input :fb_user_id
      f.input :updated_at
      f.input :created_at
    end
    f.actions         # adds the 'Submit' and 'Cancel' buttons
  end

  controller do
    def create
      @user = ::Fbuser::V1::User.new(user_params)
      if @user.save
        flash[:notice] = "Created Successfully!"
        redirect_to resource_path @user
      else
        flash[:notice] = "#{@user.errors.full_messages}"
        redirect_to new_resource_path @user
      end
    end

    def update
      @user = ::Fbuser::V1::User.find(params[:id])
      if @user.update(user_params)
        flash[:notice] = "Updated Successfully!"
        redirect_to resource_path @user
      else
        flash.now[:notice] = "#{@user.errors.full_messages}"
        render :edit
      end
    end

    def destroy
      @user = ::Fbuser::V1::User.find(params[:id])
      @user.destroy
      flash.now[:notice] = "Deleted Successfully!"
      render :index
    end

    private

      def user_params
        params.require(:user).permit(:username,:fb_user_id)
      end
  end

  index do
    selectable_column
    column :id
    column :username
    column :fb_user_id
    column :updated_at
    column :created_at
    actions
  end

  show do
    attributes_table do
      row :id
      row :username
      row :fb_user_id
      row :updated_at
      row :created_at
    end
  end


end
