require "rails_helper"

#-#-#-#-#Collection Routes#-#-#-#-#
RSpec.describe ::Fbuser::V1::User, :type => :request do
  describe "Login" do
    before(:example) do
      @token = "facebook_test_user_token"
      @header = {::Settings.main_api_header => ::Settings.main_api_key}
    end
    it "checks the response of a user" do
      hash = {token: @token}
      post '/api/1/authentication/login', hash, @header
      #pp json["api_token"]
      post '/api/1/authentication/login', hash, @header
      #pp json["api_token"]
    end
    # post /api/1/authentication/login
    it "registers a user" do

    end
    # post /api/1/authentication/login
    it "logs in a user" do

    end
  end

  describe "Logout" do
    before(:example) do
      @user = FactoryGirl.create(:fbuser_user_1)
      token = @user.tokens[0].auth_token
      @header = {::Settings.token_header => token, ::Settings.main_api_header => ::Settings.main_api_key}
    end
    # post /api/1/authentication/logout
    it "removes a token on logout" do
      expect(::Arcadex::Token.count).to eq(1)
      post "api/1/authentication/logout", nil, @header
      expect(response.status).to eq(200)
      expect(::Arcadex::Token.count).to eq(0)
    end
    # post /api/1/authentication/logout
    it "makes sure a user is logged in to logout" do
      expect(::Arcadex::Token.count).to eq(1)
      post "api/1/authentication/logout", nil, {::Settings.main_api_header => ::Settings.main_api_key}
      expect(response.status).to eq(401)
      expect(::Arcadex::Token.count).to eq(1)
    end
  end
end