require "rails_helper"

#The standard rest routes for the group controller
RSpec.describe "Fbusers controller rest routing", :type => :routing do
	routes { Fbuser::Engine.routes }

	it "routes to index" do
		expect(:get => "/api/1/users").to route_to(
			:controller => "fbuser/api/v1/users",
			:action => "index"
		)
	end
	it "routes to show" do
		expect(:get => "/api/1/users/1").to route_to(
			:controller => "fbuser/api/v1/users",
			:action => "show",
			:id => "1"
		)
	end
	it "routes to create to login" do
		expect(:post => "/api/1/users").to route_to(
			:controller => "fbuser/api/v1/authentication",
			:action => "login"
		)
	end
	it "routes to update" do
		expect(:put => "/api/1/users/1/").to route_to(
			:controller => "fbuser/api/v1/users",
			:action => "update",
			:id => "1"
		)
	end
	it "routes to update" do
		expect(:patch => "/api/1/users/1/").to route_to(
			:controller => "fbuser/api/v1/users",
			:action => "update",
			:id => "1"
		)
	end
	it "routes to delete" do
		expect(:delete => "/api/1/users/1/").to route_to(
			:controller => "fbuser/api/v1/users",
			:action => "destroy",
			:id => "1"
		)
	end
end